#include "CvGameCoreDLL.h"
#include "CvInfos.h"

// CULTURES - extra info interface due to files size limit

//
// Python interface for info classes (formerly structs)
// These are simple enough to be exposed directly - no wrappers
//

void CyInfoPythonInterface4()
{
	OutputDebugString("Python Extension Module - CyInfoPythonInterface4\n");

/************************************************************************************************/
/* CULTURES                               03/2013                                 lfgr          */
/************************************************************************************************/
	python::class_<CvCultureInfo, python::bases<CvInfoBase> >("CvCultureInfo")
		.def("getCivilizationType", &CvCultureInfo::getCivilizationType, "int /*CivilizationTypes*/ ()")
		.def("getBaseCivilization", &CvCultureInfo::getBaseCivilization, "int /*CivilizationTypes*/ ()")
		.def("getTerrainFlavour", &CvCultureInfo::getTerrainFlavour, "int /*TerrainFlavourTypes*/ ()")
		.def("getBaseWeight", &CvCultureInfo::getBaseWeight, "int ()")
		;
/************************************************************************************************/
/* CULTURES                                                                       END           */
/************************************************************************************************/

/************************************************************************************************/
/* WILDERNESS                             08/2013                                 lfgr          */
/* SpawnInfo                                                                                    */
/************************************************************************************************/
	python::class_<CvSpawnInfo, python::bases<CvInfoBase> >("CvSpawnInfo")
		.def("getCreateLair", &CvSpawnInfo::getCreateLair, "ImprovementTypes ()")
		.def("getTerrainFlavourType", &CvSpawnInfo::getTerrainFlavourType, "TerrainFlavourTypes ()")
		.def("getUnitArtStyleType", &CvSpawnInfo::getUnitArtStyleType, "UnitArtStyleTypes ()")
		.def("getWeight", &CvSpawnInfo::getWeight, "int ()")
		.def("getValidTerrainWeight", &CvSpawnInfo::getValidTerrainWeight, "int ()")
		.def("getMinWilderness", &CvSpawnInfo::getMinWilderness, "int ()")
		.def("getMaxWilderness", &CvSpawnInfo::getMaxWilderness, "int ()")
		.def("getPrereqGlobalCounter", &CvSpawnInfo::getPrereqGlobalCounter, "int ()")
		.def("getMinRandomPromotions", &CvSpawnInfo::getMinRandomPromotions, "int ()")
		.def("getMaxRandomPromotions", &CvSpawnInfo::getMaxRandomPromotions, "int ()")
		.def("getNumRandomIncludedSpawns", &CvSpawnInfo::getNumRandomIncludedSpawns, "int ()")
		.def("isNeverSpawn", &CvSpawnInfo::isNeverSpawn, "bool ()")
		.def("isExplorationResult", &CvSpawnInfo::isExplorationResult, "bool ()")
		.def("isExplorationNoPush", &CvSpawnInfo::isExplorationNoPush, "bool ()")
		.def("isAnimal", &CvSpawnInfo::isAnimal, "bool ()")
		.def("isWater", &CvSpawnInfo::isWater, "bool ()")
		.def("isNoRace", &CvSpawnInfo::isNoRace, "bool ()")
		.def("getNumSpawnUnits", &CvSpawnInfo::getNumSpawnUnits, "int ( UnitTypes eID )")
		.def("getUnitPromotions", &CvSpawnInfo::getUnitPromotions, "bool ( PromotionTypes eID )")
		.def("isIncludedSpawns", &CvSpawnInfo::isIncludedSpawns, "bool ( SpawnTypes eID )")
		.def("getPrereqTechs", &CvSpawnInfo::getPrereqTechs, "int ( TechTypes eID )")
		.def("getObsoleteTechs", &CvSpawnInfo::getObsoleteTechs, "int ( TechTypes eID )")
		;
/************************************************************************************************/
/* WILDERNESS                                                                     END           */
/************************************************************************************************/
}
